#ifndef DownloadControlerH
	#define DownloadControlerH

#include <list>
#include "Headers\sAPI_DeviceBase.h"


#define HEADERSIZE 0x4E
#define PAGESIZE  0x78
#define MEMORYBASE  0x16E
#define BASEOFFSET 0x2C
#define PROFILEBASE 0x19A

class Page
 {
	private:
		sAPI::Device *fDevice;
		unsigned char _Pb[PAGESIZE];
		int fBytes;
		int fPage;
		int fOffset;
		int fAddress;
		int inline  page(unsigned _a) const throw()
		 { return((_a - MEMORYBASE) / PAGESIZE); }
		int inline getpageaddress(int _p) const throw()
		 {return( _p * PAGESIZE) + MEMORYBASE; }
		int inline getoffset(unsigned _a) const throw()
		 { return( _a - getpageaddress(page(_a)) ); }
		
	public:
		Page(sAPI::Device *D) : fDevice(D),fAddress(0) {}
		~Page() {}
		int bytesavailable(void) const throw();
		void set(unsigned Address) throw();
		void fetch(void) throw(sAPI::Error);
		void next(void) throw();
		int get(unsigned char *ptr,int bytes) throw();

 };

class TRingBuffer
 {
	private:
		unsigned char *fdata;
		unsigned char *fptr;
		unsigned flength;
		Page *page;
		sAPI::Device *fDevice;

	public:
		TRingBuffer::TRingBuffer(sAPI::Device *D) : fDevice(D),
				 fdata(0),flength(0), page(new Page(D)) {}
		TRingBuffer::~TRingBuffer() { delete[] fdata; delete page; }
		inline unsigned char *data(void) const throw() { return fdata; }
		size_t size(size_t start, size_t end) const throw();
		inline size_t size(void) const throw() {return flength;}
		void read(unsigned address, int len) throw(sAPI::Error);
 };




 

class TDiveDownloader
 {
	private:
	   TRingBuffer *RingBuffer;
	   unsigned char *fHeader;
	   unsigned char *fProfile;
	   unsigned fDivecount;
	   unsigned ptroldest;
	   unsigned ptrnewest;
	   unsigned ptrnewer;
	   unsigned ptrolder;
	   unsigned ptrempty;
	   unsigned ptrcurrent;
	   unsigned fOffset;
	   unsigned fPage;
	   unsigned fHeaderSize;
	   unsigned fMemTop;
	   size_t fSize;

	   void fetchheader(unsigned p) throw();
	   void fetchprofile(void) throw();
	   void setheaderdata(void) throw();
	   void scanfordata(void) throw(sAPI::Error);
	   sAPI::Device *fDevice;
	   DIVE Dive;
	   friend unsigned short MakeWord(unsigned char *c) throw();

	public:
	   TDiveDownloader(sAPI::Device *D, PROFILEPTRS &M);
	   bool GetDive(DIVE D) throw(sAPI::Error);
	   ~TDiveDownloader();
	   inline size_t size(void) const throw() { return fSize; }
 };

#endif
