#ifndef ProfileControlerH
	#define ProfileControlerH

#include <list>
#include "Headers/sAPI_Structures.h"
#include "Headers/sAPI_Helper.h"

typedef unsigned char  BYTE;
typedef unsigned short WORD;


class TProfileControl
 {
	public:


 	struct TEvent
	 {
		BYTE fType;
		BYTE fID;
		BYTE fUN;
		BYTE fGas;
		BYTE fSec;
		WORD fHeading;
		int fTime;
	 };


		TProfileControl(DIVE d);
		~TProfileControl();
		bool next(void) throw();
		int inline depth(void) throw() { return int(fDepth);  }
		int inline press(void) throw() { return int(fPress); }
		int inline time(bool x = false) const throw() { if(x) return fTimeStore; return fTime; }
		bool inline isevent(void) const throw() {	return fEvent;  }
		void inline eventcomplete(void) throw() { Event.clear(); fEvent = false; }
		bool inline havetempurature(void) const throw() { return fTemperatureflag; }
		char inline temp(void) const throw() { return fTemp; }
		bool inline done(void) const throw() { return fDone;  }
		TEvent *getevent(void) throw();
		bool inline havepressure(void) const throw() { return UsePressure;  }
		WORD inline MaxPressure(void) const throw() { return fMaxPressure; }
		WORD inline MinPressure(void) const throw() { return fMinPressure; }

	private:
		DIVE fD;
		std::list<struct TEvent> Event;
		std::list<struct TEvent>::iterator eventitor;
		bool fEvent;
		bool fDone;
		bool fTemperatureflag;
		BYTE *fPTR;
		WORD fEventMarker;
		WORD fCurrentEventMarker;
		int fTime;
		int fTimeStore;
		int fTimeInterval;
		int fTemperatureInterval;
		int fTemperatureCount;
		int fProfileLength;
        bool UsePressure;
        bool fFirstPressure;
		WORD fOffset;
		WORD fDepth;
		WORD fPress;
        WORD fMaxPressure;
        WORD fMinPressure;
		char fTemp;

		bool need(int x) const throw();
		bool readevents(void) throw();
		WORD readword(void) throw();
		BYTE readbyte(void) throw();
		friend unsigned short MakeWord(unsigned char *c) throw();


 };

 #endif
 
