#ifndef TGeneraterH
	#define TGeneraterH

#include <vcl.h>
#include "Headers\TDCDML.h"
#include "Headers\sAPI_Structures.h"
#include "Headers\sAPI_Error.h"
#include "Headers\ProfileControler.h"
#include "UnitConvert\UnitConverter.h"
#include <tversion.h>

typedef std::list<pDIVE_DATA> DIVELIST;


extern unsigned char GetPersonalSetting(unsigned char p);
extern unsigned char GetAltitudeSetting(unsigned char p);


class OutputGenerater
 {
     protected:
     	friend unsigned char GetPersonalSetting(unsigned char p);
		friend unsigned char GetAltitudeSetting(unsigned char p);
        const int M_Model;
	 public:
		OutputGenerater(int m) : M_Model(m) {}
        int Model() { return M_Model; }
		virtual ~OutputGenerater() {}
		virtual void Generate(DCDMLDocument& Doc)=0;
 };

class OutputGeneraterT1 : public OutputGenerater
 {
    protected:
		DCDML_Node body;
		DCDML_Node dives;
		DCDML_Node devicenode;
		pDEVICE_DATA fDeviceInfo;
		DIVES *fDives;
		void buildsettingstag(DCDML_Node Node,int t,const char *data) throw();
		virtual void BuildDeviceData(void)=0;
        static const char * const OutputGeneraterT1::DeviceDatastrings[];
        static const char * const OutputGeneraterT1::DiveDatastrings[];
		static const char * const OutputGeneraterT1::bookmark[];
		
	public:
		OutputGeneraterT1(pDEVICE_DATA p,DIVES *d,int m)
			: OutputGenerater(m), fDeviceInfo(p),fDives(d) {}
		virtual ~OutputGeneraterT1() {}
		virtual void Generate(DCDMLDocument& Doc)=0;
 };
 
class OutputGeneraterT1D1 : public OutputGeneraterT1
 {
	private:
		double fDepth;
		AnsiString s;
		AnsiString buildserialnumber(unsigned char *data);
		int parcedivedata(pDIVE_DATA DiveData);
		void BuildDeviceData(void);

	public:
		OutputGeneraterT1D1(pDEVICE_DATA p,DIVES *d,int m) : OutputGeneraterT1(p,d,m),fDepth(0) {}
		~OutputGeneraterT1D1(){}
		virtual void Generate(DCDMLDocument& Doc);
 };

class OutputGeneraterT1D2 : public OutputGeneraterT1
 {
	private:
		TProfileControl *PC;
		AnsiString s;
		void parcedivedata(pDIVE_DATA DiveData);
		void BuildDeviceData(void);
		void buildXMLevent(DCDML_Node N,TEvent*E);
		int fetchdepthFT(int Datum);
		void buildxmldive(DCDML_Node Node,pDIVE_DATA d);
		void setvariables(TProfileControl& P,int& MD,int &ST,int &ET,int &DT);
		AnsiString buildserialnumber(unsigned char * sn);

	public:
		OutputGeneraterT1D2(pDEVICE_DATA p,DIVES *d,int m) : OutputGeneraterT1(p,d,m), PC(0) {}
		~OutputGeneraterT1D2(){ if(PC) delete PC;}
		virtual void Generate(DCDMLDocument& Doc);
 };
 


#endif
