
#ifndef sAPI_DEVICES_H
   #define sAPI_DEVICES_H

#include "headers\sapi_device.h"
#include "headers\sapi_devices_Comm.h"
#include "headers\downloadcontroler.h"

class sAPI_Device_Type1 : public sAPI_Device, public sAPI_CommModel1
 {
	  private:
		bool fIsFirstDive;
		bool fLastDive;
		sAPI_Stack *S;
		bool parce_divedata(DIVE data);
		void sAPI_Device_Type1::dobyteswap( unsigned short *D);
		void swapbytes(DEVICE_DATA& data);
		void GetaDivesData(unsigned char cmd,volatile const bool& terminate);
		bool GetFirstDive(DIVE Data,volatile const bool& terminate);
		bool GetNextDive(DIVE Data,volatile const bool& terminate);

	  public:
		sAPI_Device_Type1(const wchar_t * const port,int delay);
		virtual ~sAPI_Device_Type1();
		int Model(void) { return MemModel; }
		void Open(int tries,volatile const bool& terminate);
		int Read(unsigned address,int bytes,BYTE *data) throw(w_std::runtime_error);
		int Write(unsigned address,int bytes,BYTE *data) throw(w_std::runtime_error);
		void InitDownload(void);
		bool DownloadDive(volatile const bool& terminate);
		void DownloadDevice(volatile const bool& terminate);
		void MakeOutput(DCDMLDocument& Doc,unsigned OutputOptions =0);
 };

class sAPI_Device_TypeD_Comm : public sAPI_Device, public sAPI_CommModel2
 {
	 private:
		void InitDownload(void) {}
		bool DownloadDive(volatile const bool& terminate) {return 0;}
		void DownloadDevice(volatile const bool& terminate) {}
		void MakeOutput(DCDMLDocument& s,unsigned OutputOptions =0) {}

	 protected:
		void getheader(void);

	 public:
		sAPI_Device_TypeD_Comm(const wchar_t * const port);
        ~sAPI_Device_TypeD_Comm(){}
		int Model(void) { return MemModel; }
		void Open(int tries,volatile const bool& terminate);
		int Read(unsigned address,int bytes,BYTE *data);
		int Write(unsigned address,int bytes,BYTE *data);
 };


class sAPI_Device_TypeD : public sAPI_Device_TypeD_Comm
 {
	 private:
		bool fIsFirstDive;
		bool fLastDive;

	 protected:
		TDiveDownloader *DownloadControl;
		void BuildDeviceData(void);
		bool isfirstdive(void) { return fIsFirstDive;}
		void FirstDiveCompleted(void) { fIsFirstDive = false;}
		void ResetFirstDive(void) { fIsFirstDive = true;}

	 public:
		sAPI_Device_TypeD(const wchar_t * const port);
		virtual ~sAPI_Device_TypeD() { }
		void InitDownload(void);
		bool DownloadDive(volatile const bool& terminate);
		void DownloadDevice(volatile const bool& terminate);
		void MakeOutput(DCDMLDocument& s,unsigned OutputOptions =0);
 };


class sAPI_Device_TypeC2V2_Comm : public sAPI_Device, public sAPI_CommModel3
 {
	 private:
		bool fIsFirstDive;
		bool fLastDive;
		void InitDownload(void)  {}
		bool DownloadDive(volatile const bool& terminate) {return 0;}
		void DownloadDevice(volatile const bool& terminate)  {}
		void MakeOutput(DCDMLDocument& s,unsigned OutputOptions =0) {} 

	 protected:
		void getheader(void);

	 public:
		sAPI_Device_TypeC2V2_Comm(const wchar_t * const port);
		virtual ~sAPI_Device_TypeC2V2_Comm() {  }
		int Model(void) { return MemModel; }
		void Open(int tries,volatile const bool& terminate);
		int Read(unsigned address,int bytes,BYTE *data);
		int Write(unsigned address,int bytes,BYTE *data);
 };

class sAPI_Device_TypeC2V2 : public sAPI_Device_TypeC2V2_Comm
 {
	 private:
		bool fIsFirstDive;
		bool fLastDive;

	 protected:
		TDiveDownloader *DownloadControl;
		void BuildDeviceData(void);
		bool isfirstdive(void) { return fIsFirstDive;}
		void FirstDiveCompleted(void) { fIsFirstDive = false;}
		void ResetFirstDive(void) { fIsFirstDive = true;}

	 public:
		sAPI_Device_TypeC2V2(const wchar_t * const port);
		virtual ~sAPI_Device_TypeC2V2() { }
		void InitDownload(void);
		bool DownloadDive(volatile const bool& terminate);
		void DownloadDevice(volatile const bool& terminate);
		void MakeOutput(DCDMLDocument& s,unsigned OutputOptions =0);
 };


class sAPI_Device_TypeDF : public sAPI_Device, public sAPI_CommModel2F

 {
	 private:
		bool fIsFirstDive;
		bool fLastDive;

 	 protected:
		TDiveDownloader *DownloadControl;
		void BuildDeviceData(void);
		bool isfirstdive(void) { return fIsFirstDive;}
		void FirstDiveCompleted(void) { fIsFirstDive = false;}
		void ResetFirstDive(void) { fIsFirstDive = true;}
		void gettypedata(void);
		sAPI_Comm *fDevice;
	 public:
		sAPI_Device_TypeDF(const wchar_t * const port);
		virtual ~sAPI_Device_TypeDF();
		int Model(void) { return MemModel; }
		void Open(int tries,volatile const bool& terminate);
		void InitDownload(void);
		bool DownloadDive(volatile const bool& terminate);
		void DownloadDevice(volatile const bool& terminate);
		void MakeOutput(DCDMLDocument& s,unsigned OutputOptions =0);
		int Read(unsigned address,int bytes,BYTE *data);
		int Write(unsigned address,int bytes,BYTE *data);
 };

 #endif

