
/*
    
    sAPI_Helper.h -  Various Enumerations used by the program
    
    Copyright (C) 2008  by James Connell

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef sAPI_HelperH
#define sAPI_HelperH

//#include "Headers\sAPI_Structures.h"

enum Event_Codes { EVENT_MARKER = 1, SURFACED, IS_EVENT, USER_EVENT, GASSWITCH_EVENT };

enum Dive_Event { SAFETY_REQUIRED=1 ,DECO=3,  FAST_ASCENT=4 , CEILING =5, SAFETY_MISSED=6,
		ASCEND =7, DIVE_TIME =8, DEPTHALARM=9, AIR_TIME=0xD, RGBM=0xE , D6GASCHANGE=0xF, D9GASCHANGE=0xFF};

enum ProfileCodes { pcNA1 = 0x79, pcSLOW, pcVIOLATION, pcBOOKMARK, pcSURFACED, pcDECO, pcCEILING, pcEND, pcMISSEDSTOP,pcEOD,
		 pcWORKLOAD, pcNA2, pcCOLDWATER, pcNA3, pcGASCHANGE, pcHEADING };

enum ComputerMode { mAIR, mNITROX, mGAUGE };

enum APSettings { csPERSONAL, csALTITUDE };

enum ComputerModel { cmSTINGER = 3,cmMOSQUITO = 4,cmD3 = 5, cmVIPER = 0xA,
	  cmVYTEC = 0xB, cmCOBRA = 0xC, cmGEKKO = 0xD, cmD9 = 0xE, cmD6 = 0xF,
	  cmVYPER2 = 0x10, cmCOBRA2 = 0x11, cmD4 = 0x12, cmVYPER3 = 0x13,
	  cmCOBRA3 = 0x14,cmVYPERAIR = 0x15, cmENDOFLIST = 0xFF };

enum SampleRate { sr1s, sr10s, sr20s, sr30s, sr60s, srDEFAULTs };

enum MemoryModel { mmUNKNOWNMEMORYMODEL=0,  mmMEMORYMODEL_1 = 0x1, mmMEMORYMODEL_2=0x2, mmMEMORYMODEL_3=0x4, mmMEMORYMODEL_4=0x8 };

enum DeviceOptions {  odDevice1=0x1,odDevice2=0x2,odDevice3=0x4,odDevice4=0x8,odDeviceAll=0xF,
						odReserved1 = 0x10, odReserved2 = 0x20,
                odDeviceOption_Debug=0x40, odDeviceOption_FileDebug = 0x80 	 };

enum OutputOptions { ooUseFullTags=0x1000, ooUseFormat=0x2000, ooUTF8=0x4000, ooUTF16=0x8000,
		ooVersion=0x300, ooVersion1=0x100, ooVersion2=0x200,
        ooUnits=0xE0000,ooUnitsImperial=0x20000,ooUnitsMetric=0x40000,ooUnitsScientific=0x80000    };


enum USE_UNITS { Units_Imperial=ooUnitsImperial, Units_Metric=ooUnitsMetric, Units_Scientific=ooUnitsScientific };


//typedef enum GetDive_t DiveIterator;

#endif
