//---------------------------------------------------------------------------


#include "XMLOutput\xmldump.h"

#include "Headers\Enumerations.h"


using namespace std;

extern ofstream Out;

extern pCOMP_DATA Comp_Data;

DIVE_DATA * DiveData;
bool dataloaded = false;
bool isDcomp =false;
divedatafetchroutine parcedivedata;
divedatafetchroutine pdarray[] = {parcedivedata_V0,parcedivedata_V1};

const char *CompDatastrings[] = { "MaxDepth","TotalDiveTime","TotalDives",
"ComputerModel","FirmwareVersion.major","SerialNumber", "UnknownData1", "PersonalInfo",
"UnknownData2", "RingBufferPTR", "SampleInterval", "PersonalSetting",
"AltitudeSetting", "MaxFreeDiveDepth", "MaxFreeDiveTime","UnknownData4","Clock", "Units",
"Mode", "Light", "AlarmEnables", "AlarmTime","AlarmDepth", "UnknownData5" };

const  char *DiveDatastrings[] = { "SurfaceIntervalMinutes","SurfaceIntervalHours",
"DiveNumber", "SampleInterval", "PersonalSetting", "StartingPressure",
"GasMix", "FO2", "StartingAirTemp", "Year","Month", "Day", "Hour", "Minute",
"TempAtDepth", "EndingTemp", "EndingPressure", "CNSClock","AltitudeSetting"};

const char *bookmark[] = { "N1","Slow","Violation","User","Surface","Deco","Ceiling","End","Stop","EOD","Workload","N2","ColdWater","N3","GasSwitch","Heading"};
//enum sAPI_ProfileCodes { pcNA1 = 0x79, pcSLOW, pcVIOLATION, pcBOOKMARK, pcSURFACED, pcDECO, pcCEILING, pcEND, pcMISSEDSTOP,pcEOD,
//		 pcWORKLOAD, pcNA2, pcCOLDWATER, pcNA3, pcGASCHANGE ,pcHEADING};
//---------------------------------------------------------------------------

void SUUNTOAPI_API __stdcall sAPI_ConvertDataToXML(const wchar_t *name,pCOMP_DATA Data,unsigned short ver)
 {
    int flag = false;
	Comp_Data = Data;
	ver &= 0x2f;
    parcedivedata = pdarray[ver];
	Out.open(name,ios_base::out | ios_base::trunc);
	if(!Out.is_open())
	 {
		Out.close();
		return;
	 }

    Out << "<?xml version=\"1.0\"  ?>\n\n";
	Out << "<SuuntoDownload>\n\n";

    Comp_Data->MaxDepth /= 128;
    Comp_Data->AlarmDepth /= 128;

    BuildXMLCompData();
	DiveData = Comp_Data->DiveData;
	if(DiveData != NULL)
 	 {
		while( DiveData != NULL )
		 {
				Out << "<DiveData>\n";
				if(!parcedivedata(DiveData)) flag = true;;
				Out << "</DiveData>\n";
				DiveData = DiveData->NextDive;
				if(flag) break;
		 }
	 }
	else  Out << "<!--   No Dives   -->";
	Out << "\n\n</SuuntoDownload>";
	Out.close();

  }
  
string MakeXMLTagTrailer(const string &c)
 {
    string s = string("</") + c + string(">\n");
    return s;
//    return  string("</") + c + string(">\n");
 }
string MakeXMLTagHeader(const string &c)
 {
    string s = string("    <")+ c + string(">");
    return s;
//    return string("    <")+ c + string(">");
 }
string MakeXMLTagTrailer( const char *c)
 {
    string s = string("</") + c + string(">\n");
    return s;
//    return  string("</") + c + string(">\n");
 }
string MakeXMLTagHeader( const char *c)
 {
    string s = string("    <")+ c + string(">");
    return s;
//    return  string("    <")+ c + string(">");
 }

void MakeXMLTag(string c, unsigned char x)
 {
	char data[12];
	sprintf(data,"%d",(unsigned)x);
    Out <<  MakeXMLTagHeader(c) << data << MakeXMLTagTrailer(c);
 }
void MakeXMLTag(string c, char x)
 {
	char data[12];
	sprintf(data,"%d",(unsigned)x);
    Out <<  MakeXMLTagHeader(c) << data << MakeXMLTagTrailer(c);
 }
void MakeXMLTag(string c, unsigned short x)
 {
	char data[12];
	sprintf(data,"%d",(unsigned)x);
    Out <<  MakeXMLTagHeader(c) << data << MakeXMLTagTrailer(c);
 }

void MakeXMLTag(string c,unsigned char *x)
 {
	char data[12];
	sprintf(data,"%d",(unsigned)*x);
    Out <<  MakeXMLTagHeader(c) << data << MakeXMLTagTrailer(c);
}
void MakeXMLTag(string c,const char *x)
 {
    Out <<  MakeXMLTagHeader(c) << x << MakeXMLTagTrailer(c);
 }
void MakeXMLFlagEventTag(string c)
 {
    Out <<  "   <" << c << " />";
 }

char *buildserialnumber()
 {
    unsigned long result;
    static char st[15];
    unsigned char *data = Comp_Data->SerialNumber;
    result = data[3];
    result += data[2]*100;
    result += data[1]*10000;
    result += data[0]*1000000;
    sprintf(st,"%u",result);
    return st;
 }


#define XMLTag(n,x)  MakeXMLTag(CompDatastrings[(n)],(x))
 void  BuildXMLCompData(void)
 {
    Out << "<ComputerSettings>\n";
 
    XMLTag(0,Comp_Data->MaxDepth);
    XMLTag(1,Comp_Data->TotalDiveTime);
    XMLTag(2,Comp_Data->TotalDives);
    XMLTag(3,Comp_Data->ComputerModel);
    XMLTag(4,Comp_Data->FirmwareVersionMjr);
    XMLTag(5,buildserialnumber());
    XMLTag(7,(char *)Comp_Data->PersonalInfo);
    XMLTag(10,Comp_Data->SampleInterval);
    XMLTag(11,GetPersonalSetting(Comp_Data->ConservationSettings));
    XMLTag(12,GetAltitudeSetting(Comp_Data->ConservationSettings));
    XMLTag(13,Comp_Data->MaxFreeDiveDepth);
    XMLTag(14,Comp_Data->MaxFreeDiveTime);
    XMLTag(16,Comp_Data->_12_24Clock);
    XMLTag(17,Comp_Data->Units);
    XMLTag(18,Comp_Data->Mode);
    XMLTag(19,Comp_Data->Light);
    XMLTag(20,Comp_Data->AlarmEnables);
    XMLTag(21,Comp_Data->AlarmTime);
    XMLTag(22,Comp_Data->AlarmDepth);

    Out << "</ComputerSettings>\n\n";
 }

unsigned char GetPersonalSetting(unsigned char p)
 {
     return p / 3;
 }

unsigned char GetAltitudeSetting(unsigned char p)
 {
    return p % 3;
 }

// original version
int  parcedivedata_V0(pDIVE_DATA DiveData)
 {
	const std::string s = "Bookmark";
    unsigned char c;
    unsigned char * Profileptr = (unsigned char *)(&DiveData->SurfaceIntervalMinutes);
    for(int i=0; i<14; ++i) // get dive data struct
     {
        if(i == 4)
         {
            MakeXMLTag(DiveDatastrings[i],GetPersonalSetting(Profileptr[i]));
            MakeXMLTag("AltitudeSetting",GetAltitudeSetting(Profileptr[i]));
         }
        else MakeXMLTag(DiveDatastrings[i],Profileptr[i]);
     }
    Profileptr = DiveData->Profile;
    Out << "         <DiveProfile>\n";

    for(int i =0 ; i < DiveData->ProfileLength; ++i)
    {
        c = *Profileptr++;
        Out << "         ";
        if( c < pcNA1  || c > pcGASCHANGE )
         {
            MakeXMLTag("Datum",(char)c);
         }
        else if ( c == pcGASCHANGE )
         {
            c=*Profileptr++;
            ++i;
            Out << MakeXMLTagHeader(s);
            MakeXMLTag(bookmark[c - pcNA1],static_cast<unsigned short>(c));
            Out << MakeXMLTagTrailer(s);
         }
        else MakeXMLTag(s,bookmark[c - pcNA1]);
     }

    Out << "         </DiveProfile>\n";

    Profileptr = ((unsigned char *) (&DiveData->TempAtDepth));
    for(int i=0; i<4; ++i)
     {
        MakeXMLTag(DiveDatastrings[i+14],Profileptr[i]);
     }
    return true;
 }
 

 // version # 1
int  parcedivedata_V1(pDIVE_DATA DiveData)
 {
    const std::string s = "Event";
    unsigned short x;
    unsigned char c;
    unsigned char * Profileptr = (unsigned char *)(&DiveData->SurfaceIntervalMinutes);
    for(int i=0; i<14; ++i) // get dive data struct
     {
        if(i == 4)
         {
            MakeXMLTag(DiveDatastrings[i],GetPersonalSetting(Profileptr[i]));
            MakeXMLTag("AltitudeSetting",GetAltitudeSetting(Profileptr[i]));
         }
        else MakeXMLTag(DiveDatastrings[i],Profileptr[i]);
     }
    Profileptr = DiveData->Profile;
    Out << "         <DiveProfile>\n";

    for(int i =0 ; i < DiveData->ProfileLength; ++i)
    {
        c = *Profileptr++;
        Out << "         ";

        if( c < pcNA1  || c > pcGASCHANGE )
         {
            MakeXMLTag("Datum",(char)c);
         }
        else
         {
            Out << MakeXMLTagHeader(s);
            switch(c)
             {
                case pcNA1:
                case pcSLOW:
                case pcVIOLATION:
                case pcBOOKMARK:
                    if(isDcomp == true) {  c= pcHEADING; break; }
                case pcSURFACED:
                case pcDECO:
                case pcCEILING:
                case pcEND:
                case pcMISSEDSTOP:
                case pcEOD:
                case pcWORKLOAD:
                case pcNA2:
                case pcCOLDWATER:
                case pcNA3:
                    MakeXMLFlagEventTag(bookmark[c - pcNA1]);
                    break;

                case pcGASCHANGE:
                    x = *Profileptr++;
                    ++i;
                    MakeXMLTag(bookmark[c - pcNA1],x);
                    break;
             }
            if(c == pcHEADING )
             {
                x = *Profileptr++;
                ++i;
                x+= (*Profileptr++) <<8;
                ++i;
                MakeXMLTag(bookmark[c - pcNA1],x);
              }
            Out << MakeXMLTagTrailer(s);
         }
     }

    Out << "         </DiveProfile>\n";

    Profileptr = ((unsigned char *) (&DiveData->TempAtDepth));
    for(int i=0; i<4; ++i)
     {
        MakeXMLTag(DiveDatastrings[i+14],Profileptr[i]);
     }
    return true;
 }


