//---------------------------------------------------------------------------

#include "NewXMLDump\xmldump.h"

#include <list>
#include <stdio.h>
#include <fstream>
#include <string.h>
#include <vcl.h>
#include <MyHeaders\AnsiToUtf8.h>
#include "Headers\Enumerations.h"


typedef std::list<pDIVE_DATA> DIVELIST;
extern std::ofstream Out;

extern pCOMP_DATA Comp_Data;
extern enum sAPI_MemoryModel fMemoryModel;
std::string s;
DIVE_DATA * DiveData;
bool dataloaded = false;
bool isDcomp =false;

const char *CompDatastrings[] = { "MaxDepth","TotalDiveTime","TotalDives",
"ComputerModel","FirmwareVersion.major","SerialNumber", "UnknownData1", "PersonalInfo",
"UnknownData2", "RingBufferPTR", "SampleInterval", "PersonalSetting",
"AltitudeSetting", "MaxFreeDiveDepth", "MaxFreeDiveTime","UnknownData4","Clock", "Units",
"Mode", "Light", "AlarmEnables", "AlarmTime","AlarmDepth", "UnknownData5" };

const  char *DiveDatastrings[] = { "SurfaceIntervalMinutes","SurfaceIntervalHours",
"DiveNumber", "SampleInterval", "PersonalSetting", "StartingPressure",
"GasMix", "FO2", "StartingAirTemp", "Year","Month", "Day", "Hour", "Minute",
"TempAtDepth", "EndingTemp", "EndingPressure", "CNSClock","AltitudeSetting"};

const char *bookmark[] = { "N1","Slow","Violation","User","Surface","Deco","Ceiling","End","Stop","EOD","Workload","N2","ColdWater","N3","GasSwitch","Heading"};
//enum sAPI_ProfileCodes { pcNA1 = 0x79, pcSLOW, pcVIOLATION, pcBOOKMARK, pcSURFACED, pcDECO, pcCEILING, pcEND, pcMISSEDSTOP,pcEOD,
//		 pcWORKLOAD, pcNA2, pcCOLDWATER, pcNA3, pcGASCHANGE ,pcHEADING};
//---------------------------------------------------------------------------

DCDML_Node body;
DCDML_Node dives;
DCDMLDocument MyDoc;

DCDML_Node spressNode;
DCDML_Node epressNode;
DCDML_Node stempNode;
DCDML_Node etempNode;
DCDML_Node dtempNode;

void  __stdcall sAPI_ConvertDataToXML(const wchar_t *name,pCOMP_DATA Data,unsigned short ver)
 {
    MyDoc << DCDML_USE_FORMATTING ;
	int flag = false;
	Comp_Data = Data;
	Out.open(name,std::ios_base::out | std::ios_base::trunc);
	if(!Out.is_open())
	 {
		Out.close();
		return;
	 }


	s= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";

	body = MyDoc.Create("SuuntoDownload");

	if(fMemoryModel == mmMEMORYMODEL_2)
	 {
		//s = "<!--This Version does not support this computer model -->";
		DoVersion2XMLOutput(Comp_Data);
		s = MyDoc.Make();
		TAnsiToUtf8 Utf8(s);
		Out <<  Utf8.data();
		Out.close();
		return;
	 }

	Comp_Data->MaxDepth /= 128;
	Comp_Data->AlarmDepth /= 128;

	BuildXMLCompData();

	DIVELIST &D = Comp_Data->Dives;

	if(D.size() > 0)
 	 {
		for(DIVELIST::const_iterator  i = D.begin(); i != D.end(); ++i)
		 {
				dives = body->AddChild("DiveData");
				if(!parcedivedata(*i)) flag = true;;
				if(flag) break;
		 }
	 }
	else  body->AddComment("   No Dives   ");

	s = MyDoc.Make();
	TAnsiToUtf8 Utf8(s);
	Out <<  Utf8.data();
	Out.close();

  }


char *buildserialnumber()
 {
	unsigned long result;
	static char st[15];
	unsigned char *data = Comp_Data->SerialNumber;
	result = data[3];
	result += data[2]*100;
	result += data[1]*10000;
	result += data[0]*1000000;
	sprintf(st,"%u",result);
    return st;
 }

void buildsettingstag(DCDML_Node Node,int t,const char *data)
 {
	DCDML_Node XNode = Node->AddChild(CompDatastrings[t]);
	XNode->AddText(data);
 }

void  BuildXMLCompData(void)
 {
	AnsiString a;
	DCDML_Node Node = body->AddChild("ComputerSettings");
	a=Comp_Data->MaxDepth;
	buildsettingstag(Node,0,a.c_str());

	a=Comp_Data->TotalDiveTime;
	buildsettingstag(Node,1,a.c_str());
	a=Comp_Data->TotalDives;
	buildsettingstag(Node,2,a.c_str());
	a=Comp_Data->ComputerModel;
	buildsettingstag(Node,3,a.c_str());

	a=Comp_Data->FirmwareVersionMjr;
	buildsettingstag(Node,4,a.c_str());
	a=buildserialnumber();
	buildsettingstag(Node,5,a.c_str());
	a=(char *)Comp_Data->PersonalInfo;
	buildsettingstag(Node,7,a.c_str());
	a=Comp_Data->SampleInterval;
	buildsettingstag(Node,10,a.c_str());

	a=GetPersonalSetting(Comp_Data->ConservationSettings);
	buildsettingstag(Node,11,a.c_str());
	a=GetAltitudeSetting(Comp_Data->ConservationSettings);
	buildsettingstag(Node,12,a.c_str());
	a=Comp_Data->MaxFreeDiveDepth;
	buildsettingstag(Node,13,a.c_str());
	a=Comp_Data->MaxFreeDiveTime;
	buildsettingstag(Node,14,a.c_str());
   //	buildsettingstag(Node,15,a.c_str());
	a=Comp_Data->_12_24Clock;
	buildsettingstag(Node,16,a.c_str());
	a=Comp_Data->Units;
	buildsettingstag(Node,17,a.c_str());
	a=Comp_Data->Mode;
	buildsettingstag(Node,18,a.c_str());
	a=Comp_Data->Light;
	buildsettingstag(Node,19,a.c_str());
	a=Comp_Data->AlarmEnables;
	buildsettingstag(Node,20,a.c_str());
	a=Comp_Data->AlarmTime;
	buildsettingstag(Node,21,a.c_str());
	a=Comp_Data->AlarmDepth;
	buildsettingstag(Node,22,a.c_str());
}

unsigned char GetPersonalSetting(unsigned char p)
 {
	 return (p & 0x0F) / 3;
 }

unsigned char GetAltitudeSetting(unsigned char p)
 {
    return (p & 0x0F) % 3;
 }



 // version # 1
int  parcedivedata(pDIVE_DATA DiveData)
 {
	DCDML_Node Node ;
	const char* event = "Event";
	unsigned short x;
	unsigned char c;
	int f;
    unsigned char * Profileptr = (unsigned char *)(&DiveData->SurfaceIntervalMinutes);
    for(int i=0; i<14; ++i) // get dive data struct
     {
		AnsiString a;
		if(i == 4)
         {
			Node = dives->AddChild("PersonalSetting");
			a = GetPersonalSetting(Profileptr[i]);
			Node->AddText(a.c_str());
			Node = dives->AddChild("AltitudeSetting");
			a = GetPersonalSetting(Profileptr[i]);
			Node->AddText(a.c_str());
		 }
		else
		 {
			Node = dives->AddChild(DiveDatastrings[i]);
			Node->AddText( AnsiString(Profileptr[i]).c_str());

		 }
	 }
	Profileptr = DiveData->Profile;

	DCDML_Node data = dives->AddChild("DiveProfile");
	for(int i =0 ; i < DiveData->ProfileLength; ++i)
	{
		c = *Profileptr++;

		if( c < pcNA1  || c > pcGASCHANGE )
		 {
			Node = data->AddChild("Datum");
			f = (char)c;
			Node->AddText(AnsiString(f).c_str());
		   //	MakeXMLTag("Datum",(char)c);
         }
        else
         {
			Node = data->AddChild(event);
			switch(c)
             {
                case pcNA1:
                case pcSLOW:
                case pcVIOLATION:
                case pcBOOKMARK:
                    if(isDcomp == true) {  c= pcHEADING; break; }
                case pcSURFACED:
                case pcDECO:
				case pcCEILING:
                case pcEND:
                case pcMISSEDSTOP:
                case pcEOD:
                case pcWORKLOAD:
                case pcNA2:
                case pcCOLDWATER:
                case pcNA3:
					Node->AddChild(bookmark[c - pcNA1]);
                    break;

                case pcGASCHANGE:
                    x = *Profileptr++;
					++i;
					Node=Node->AddChild(bookmark[c - pcNA1]);
					Node->AddText(AnsiString(x).c_str());
					break;
             }
            if(c == pcHEADING )
             {
                x = *Profileptr++;
                ++i;
                x+= (*Profileptr++) <<8;
                ++i;
				Node=Node->AddChild(bookmark[c - pcNA1]);
				Node->AddText(AnsiString(x).c_str());
			  }
		 }
	 }

	Profileptr = ((unsigned char *) (&DiveData->TempAtDepth));
	for(int i=0; i<4; ++i)
	 {
		Node=data->AddChild(DiveDatastrings[i+14]);
		Node->AddText(AnsiString(Profileptr[i]).c_str());
     }
    return true;
 }

void  DoVersion2XMLOutput(pCOMP_DATA data)
{
	DCDML_Node dives;
	DCDML_Node Node = body->AddChild("ComputerSettings");
	DIVELIST &D = data->Dives;
	AnsiString a;

	a= Cm2Ft(Comp_Data->MaxDepth);
	buildsettingstag(Node,0,a.c_str());

	a=Comp_Data->TotalDiveTime;
	buildsettingstag(Node,1,a.c_str());
	a=Comp_Data->TotalDives;
	buildsettingstag(Node,2,a.c_str());
	a=Comp_Data->ComputerModel;
	buildsettingstag(Node,3,a.c_str());

	a=Comp_Data->FirmwareVersionMjr;
	buildsettingstag(Node,4,a.c_str());
	a=buildserialnumber();
	buildsettingstag(Node,5,a.c_str());
	a=(char *)Comp_Data->PersonalInfo;
	buildsettingstag(Node,7,a.c_str());
	a=Comp_Data->Units;
	buildsettingstag(Node,17,a.c_str());
	a=0;
	buildsettingstag(Node,10,a.c_str());
	a=0;
	buildsettingstag(Node,11,a.c_str());
	a=0;
	buildsettingstag(Node,12,a.c_str());

	if(D.size() > 0)
	 {
        int x=0;
		for(DIVELIST::const_iterator  b = D.begin(); b != D.end(); ++b)
		 {
				unsigned char c;
				AnsiString a;
				x++;
				unsigned char * Profileptr = (unsigned char *)(&(*b)->SurfaceIntervalMinutes);
				dives = body->AddChild("DiveData");
				for(int i=0; i<18; ++i) // get dive data struct
				 {
					switch(i)
					 {
						case 4:
							Node = dives->AddChild(DiveDatastrings[i]);
							a = GetPersonalSetting(Profileptr[i]);
							Node->AddText(a.c_str());
							Node = dives->AddChild(DiveDatastrings[18]); //"AltitudeSetting"
							a = GetPersonalSetting(Profileptr[i]);
							Node->AddText(a.c_str());
							break;
						case 5: // =Spres
							spressNode = dives->AddChild(DiveDatastrings[i]);
							break;
						case 7:
							Node = dives->AddChild(DiveDatastrings[i]);
							a = 0;
							Node->AddText(a.c_str());
							break;
						case 8:
							stempNode = dives->AddChild(DiveDatastrings[i]);
							break;
						case 14: // =dtemp
							dtempNode = dives->AddChild(DiveDatastrings[i]);
							break;
						case 15: // =Etemp
							etempNode = dives->AddChild(DiveDatastrings[i]);
							break;
						case 16: // =Epress
							epressNode = dives->AddChild(DiveDatastrings[i]);
							break;
						default:
							Node = dives->AddChild(DiveDatastrings[i]);
							a = AnsiString(Profileptr[i]);
							Node->AddText( a.c_str());

					}
				}
				DCDML_Node data = dives->AddChild("DiveProfile");

				buildxmldive(data,(*b));

				a= AnsiString((*b)->SPressure );
				spressNode->AddText(a.c_str());
				a= AnsiString((*b)->EPressure );
				epressNode->AddText(a.c_str());
				a= AnsiString((*b)->StartingAirTemp );
				stempNode->AddText(a.c_str());
				a= AnsiString((*b)->EndingTemp );
				etempNode->AddText(a.c_str());
				a= AnsiString((*b)->TempAtDepth );
				dtempNode->AddText(a.c_str());
		 }
	 }
	else  body->AddComment("   No Dives   ");

}

void setvariables(TProfileControl& P,int& MD,int &ST,int &ET,int &DT,int &SP,int &EP)
 {
	if(P.havetempurature() )
	 {
		if(ST == -99999) ST = P.temp();
		ET =P.temp();
	 }
	if(P.depth() > MD)
	 {
		MD = P.depth();
		DT = ET;
	 }
	if(SP == -99999) SP = P.press();
	EP = P.press();
 }
 
void buildxmldive(DCDML_Node Node,pDIVE_DATA d)
 {
	TProfileControl P(d);
	DCDML_Node X;
	int depth;
	int ET;
	int DT;
	int EP;
	int ft;
	int MD =0;
	int SP= -99999;
	int ST= -99999;
	fetchdepthFT(0);
	do
	 {
		if(P.next() == false)  break;
		if(P.isevent())
		 {
			//TEvent *E;
			X = Node->AddChild("Datum");
			while((/*E =*/ P.getevent())!=0)
			 {
			   /*	DCDML_Node N = X->AddChild("event");
				switch(E->fType)
				 {
					case SURFACED:
						 N->AddText("surface");
						break;
					case IS_EVENT:
						buildXMLevent(N,E);
						break;
					case USER_EVENT:
						N->AddText("user");
						break;
				 }
				 */
			 }
			P.eventcomplete();
			if(P.next() == false)  break;
			ft = fetchdepthFT(P.depth());
			setvariables(P,MD,ST,ET,DT,SP,EP);
			X->AddText(AnsiString(ft).c_str());

			continue;
		 }

		else
		 {
			setvariables(P,MD,ST,ET,DT,SP,EP);
			ft = fetchdepthFT(P.depth());

			X = Node->AddChild("Datum");
			X->AddText(AnsiString(ft).c_str());
		 }
	 } while(!P.done());

	d->SPressure = SP;
	d->EPressure =EP;
	d->StartingAirTemp =ST;
	d->EndingTemp =ET;
	d->TempAtDepth =DT;
 }

 // Old version
 /*int fetchdepthFT(int Datum)
  {
	 bool negative = false;

	 double delta, ft;
	 int remainder;
	 static int depth;
	 if(Datum == 0)
	  {
		depth =0;
		return 0;
	  }

	 if(depth > Datum)
	  {
		negative = true;
		delta = depth - D;
	  }
	 else  delta = Datum - depth;

	 ft =   delta / 30.48 ;
	 remainder =   Round(delta - (ft * 30.48));

	 depth = Datum;
	 if(negative)
	  {
		ft = -ft;
		remainder = -remainder;
	  }
	 depth -= remainder;
	 return Round(ft);
  }*/

// new version 10/20/07
int fetchdepthFT(int Datum)
  {
	 bool negative = false;

	 double delta, ft;
	 int remainder;
	 static int depth;

	 // reset variables
	 if(Datum == 0)
	  {
		depth =0;
		return 0;
	  }

	  // now get change (in CM)
	 if(depth > Datum)
	  { // have gone up since last sample
		negative = true;
		delta = depth - Datum;
	  }
	 else  delta = Datum - depth;

	 ft = delta / 30.48 ;
	 //remainder =   Round(delta - (ft * 30.48));
	 remainder =   Round(fmod(delta,30.48));

	 depth = Datum;
	 if(negative)
	  {
		depth += remainder;
		return Round(ft * -1);
	  }
	 depth -= remainder;
	 return Round(ft);
  }

void buildXMLevent(DCDML_Node N,TEvent*E)
 {
	std::string evnt;
	switch(E->fID)
	 {
		case ASCENT:
				N->AddText("slow");
				break;
		case DECO:
				N->AddText("deco");
				break;
		case CEILING:
				N->AddText("ceiling");
				break;
	 }
 }

