

#include <vcl.h>
#include "Headers\GeneraterT1.h"
#include <trace.h>
#include "Headers\sAPI_Helper.h"


void OutputGeneraterT1D1::Generate(DCDMLDocument& Doc)
 {
	body = Doc.Create("SuuntoDownload");

	Trace(trace::TraceInfo,"Generate::Device(1),Type(1): Begin \'SuuntoDownload\'");
	BuildDeviceData();

	if(fDives->size() > 0)
	 {
		int q(0);
		for(DIVES::const_iterator  i(fDives->begin()); i != fDives->end(); ++i)
		 {
				Trace(trace::TraceInfo,"Generate::Device(1),Type(1): Dive %u",++q);
				dives = body->AddChild("DiveData");
				if(0==parcedivedata(*i)) break;
		 }
	 }
	else
	 {
		Trace(trace::TraceInfo,"Generate::Device(1),Type(1): No Dives");
		body->AddComment("   No Dives   ");
	 }
	Trace(trace::TraceInfo,"Generate::Make() Building Document");
	Doc.Make();
 }

AnsiString OutputGeneraterT1D1::buildserialnumber(unsigned char *data)
 {
	static AnsiString s;
	unsigned long result(data[3]);
	result += data[2]*100;
	result += data[1]*10000;
	result += data[0]*1000000;
	s = result;
    return s;
 }

 // version # 1
int  OutputGeneraterT1D1::parcedivedata(DIVE DiveData)
 {
	DCDML_Node Node ;
	const char* const event("Event");
	//unsigned short x;
	//unsigned char c;
	unsigned char * Profileptr((unsigned char *)(&DiveData->SurfaceIntervalMinutes));
	AnsiString a;
	
	fDepth =0;

	for(int i(0); i<14; ++i) // get dive data struct
	 {
		if(i == 4)
         {
			Node = dives->AddChild("PersonalSetting");
			a= GetPersonalSetting(Profileptr[i]);
			Node->AddText(a.c_str());
			Node = dives->AddChild("AltitudeSetting");
			a= GetPersonalSetting(Profileptr[i]);
			Node->AddText(a.c_str());
	   /*
			a("%u", fDeviceInfo->ConservationSettings & 0x10 ? 1 : 0);
			Node = dives->AddChild("RGBM");
			Node->AddText(a.c_str());
		*/
		 }
		else
		 {
			Node = dives->AddChild(DiveDatastrings[i]);
			a= Profileptr[i];
			Node->AddText( a.c_str());

		 }
	 }
	Profileptr = DiveData->Profile;

	DCDML_Node data(dives->AddChild("DiveProfile"));
	for(int i(0) ; i < DiveData->ProfileLength; ++i)
	{
		unsigned char c(*Profileptr++);

		if( c < pcNA1  || c > pcGASCHANGE )
		 {
			fDepth = (char)c;
			AnsiString ss((int)fDepth);
			Node = data->AddChild("Datum");
			Node->AddText(ss.c_str());
         }
        else
         {
			Node = data->AddChild(event);
			switch(c)
             {
                case pcNA1:
				case pcSLOW:
                case pcVIOLATION:
				case pcBOOKMARK:
				case pcSURFACED:
                case pcDECO:
				case pcCEILING:
                case pcEND:
                case pcMISSEDSTOP:
                case pcEOD:
                case pcWORKLOAD:
                case pcNA2:
                case pcCOLDWATER:
                case pcNA3:
					Node->AddChild(bookmark[c - pcNA1]);
                    break;

                case pcGASCHANGE:
					a= *Profileptr++;
					++i;
					Node=Node->AddChild(bookmark[c - pcNA1]);
					Node->AddText(a.c_str());
					break;
			 }
			if(c == pcHEADING )
			 {
				unsigned short x(*Profileptr);
				x += (*(Profileptr+1)) <<8;
				i+=2;
				Profileptr+=2;
				a = x;
				Node = Node->AddChild(bookmark[c - pcNA1]);
				Node->AddText(a.c_str());
			  }
		 }
	 }

	Profileptr = ((unsigned char *) (&DiveData->TempAtDepth));
	for(int i(0); i<4; ++i)
	 {
		a=Profileptr[i];
		Node=data->AddChild(DiveDatastrings[i+14]);
		Node->AddText(a.c_str());
     }
    return true;
 }

void  OutputGeneraterT1D1::BuildDeviceData(void)
 {
	devicenode = body->AddChild("ComputerSettings");

	AnsiString a( (int)(fDeviceInfo->MaxDepth  ) / 128);
	buildsettingstag(devicenode,0,a.c_str());

	a= fDeviceInfo->TotalDiveTime;
	buildsettingstag(devicenode,1,a.c_str());
	a=fDeviceInfo->TotalDives;
	buildsettingstag(devicenode,2,a.c_str());
	a=fDeviceInfo->ComputerModel;
	buildsettingstag(devicenode,3,a.c_str());
	a=fDeviceInfo->MaxFreeDiveDepth;
	buildsettingstag(devicenode,13,a.c_str());
	a=fDeviceInfo->MaxFreeDiveTime;
	buildsettingstag(devicenode,14,a.c_str());
   //	buildsettingstag(Node,15,a.c_str());
	a=fDeviceInfo->ClockStyle;
	buildsettingstag(devicenode,16,a.c_str());
	a=fDeviceInfo->Units;
	buildsettingstag(devicenode,17,a.c_str());

	a=fDeviceInfo->FirmwareVersionMjr;
	buildsettingstag(devicenode,4,a.c_str());

	a=buildserialnumber(fDeviceInfo->SerialNumber);
	buildsettingstag(devicenode,5,a.c_str());
	a= (char *)fDeviceInfo->PersonalInfo;
	buildsettingstag(devicenode,7,a.c_str());
	a=fDeviceInfo->SampleInterval;
	buildsettingstag(devicenode,10,a.c_str());

	a=GetPersonalSetting(fDeviceInfo->ConservationSettings);
	buildsettingstag(devicenode,11,a.c_str());
	a=GetAltitudeSetting(fDeviceInfo->ConservationSettings);
	buildsettingstag(devicenode,12,a.c_str());

	/*if(fDeviceInfo->ConservationSettings & 0x10)
		buildsettingstag(devicenode,24,"100");
	else buildsettingstag(devicenode,24,"50");
	*/
	a=fDeviceInfo->Mode;
	buildsettingstag(devicenode,18,a.c_str());
	a=fDeviceInfo->Light&0x7F;
	buildsettingstag(devicenode,19,a.c_str());
	a=fDeviceInfo->AlarmEnables;
	buildsettingstag(devicenode,20,a.c_str());
	a=fDeviceInfo->AlarmTime;
	buildsettingstag(devicenode,21,a.c_str());

	a = (int)(fDeviceInfo->AlarmDepth/128 );
	buildsettingstag(devicenode,22,a.c_str());
 }


