

#include <vcl.h>
#include "Headers\GeneraterT2.h"
#include <trace.h>
#include "Headers\sAPI_Helper.h"


void OutputGeneraterT2D1::Generate(DCDMLDocument& Doc)
 {

	Trace(trace::TraceInfo,"Generate::Device(1),Type(2): Begin ");

	//ToDo: change to use the struct of nodes!
	//BuildNodes(Doc);

	DCDML_Node DCDMLNode(Doc.Create("dcdml"));

	dogenerater(DCDMLNode);

	basic_generate(DCDMLNode);

	// <device>
	DCDML_Node deviceNode = DCDMLNode->AddChild("device");
	dodevice(deviceNode);
	// </device>
	// <settings>
	DCDML_Node settingsNode = DCDMLNode->AddChild("settings");
	dosettings(settingsNode);
	// </settings>
	// <history>
	DCDML_Node historyNode = DCDMLNode->AddChild("history");
	dohistory(historyNode);
	// </history>
	// <profiledata>
	DCDML_Node profileNode = DCDMLNode->AddChild("profiledata");
	doprofile(profileNode,fDives);   // <--- use list of dives

	Trace(trace::TraceInfo,"Generate::Make() Building Document");
	Doc.Make();

  }

//void OutputGeneraterT2D1::Generate(DCDMLDocument& Doc)
// {
//	Trace(trace::TraceInfo,"Generate::Device=1 Type=2: Begin ");
//
//	BuildNodes(Doc);
//	basic_generate(	NodeList.DCDMLNode);
//	dosettings(NodeList.settingsNode);
//	root_generate(Doc);
//
//	Trace(trace::TraceInfo,"Generate::Device=1 Type=2: End ");
// }

void OutputGeneraterT2D1::dodevice( DCDML_Node deviceNode)
 {
	deviceNode->Attributes[devicestrings[0]] = devicestrings[1];
	deviceNode->Attributes[devicestrings[2]] = getmodelstr();
	deviceNode->Attributes[devicestrings[3]] = buildserialnumber();
	deviceNode->Attributes[devicestrings[4]] = getversioninfo();

//	deviceNode->Attributes["vendor"] = "Suunto Oy";
//	deviceNode->Attributes["model"] = getmodelstr();
//	deviceNode->Attributes["serial"] = buildserialnumber();
//	deviceNode->Attributes["version"] = getversioninfo();

 }

char * OutputGeneraterT2D1::buildserialnumber(void)
 {
    unsigned char * data(fDeviceInfo->SerialNumber);
	unsigned long result(data[3]);
	result += data[2]*100;
	result += data[1]*10000;
	result += data[0]*1000000;
 	sprintf(stringbuffer,"%u",result);
	return stringbuffer;
 }

void OutputGeneraterT2D1::dohistory(DCDML_Node historyNode)
 {
	historyNode->Attributes[historystrings[0]] = US2str(fDeviceInfo->TotalDives);
	historyNode->Attributes[historystrings[1]] = makemaxdepth(fDeviceInfo->MaxDepth/128);
	historyNode->Attributes[historystrings[2]] = makedivetime(fDeviceInfo->TotalDiveTime);
	if(fDeviceInfo->MaxFreeDiveDepth > 0)
    	historyNode->Attributes[historystrings[3]] = makemaxdepth(fDeviceInfo->MaxFreeDiveDepth/128);
	if(fDeviceInfo->MaxFreeDiveTime > 0)
        historyNode->Attributes[historystrings[4]] = US2str(fDeviceInfo->MaxFreeDiveTime);

//	historyNode->Attributes["dives"] = US2str(fDeviceInfo->TotalDives);
//	historyNode->Attributes["maxdepth"] = makemaxdepth(fDeviceInfo->MaxDepth/128);
//	historyNode->Attributes["divetime"] = makedivetime(fDeviceInfo->TotalDiveTime);
//	if(fDeviceInfo->MaxFreeDiveDepth > 0)
//		historyNode->Attributes["freedivemaxdepth"] = makemaxdepth(fDeviceInfo->MaxFreeDiveDepth/128);
//	if(fDeviceInfo->MaxFreeDiveTime > 0)
//		historyNode->Attributes["freedivetime"] = US2str(fDeviceInfo->MaxFreeDiveTime);
 }


char *OutputGeneraterT2D1::getpersonalinfo(void)
 {
	strncpy(stringbuffer,fDeviceInfo->PersonalInfo, 28);
	stringbuffer[28] ='\0';
	return stringbuffer;
 }

 void OutputGeneraterT2D1::dosettings( DCDML_Node settingsNode)
 {
    settingsNode->Attributes[units_str] = fDeviceInfo->Units ?  metric_str : imperial_str;
    settingsNode->Attributes["timeformat"] = fDeviceInfo->ClockStyle ? "24H" : "12H";
    settingsNode->Attributes["sampleinterval"] = UC2str(fDeviceInfo->SampleInterval);
    settingsNode->Attributes[("divemode")] = getdivemode();
    settingsNode->Attributes[("personalfactor")] = getpersonalsetting(fDeviceInfo->ConservationSettings);
    settingsNode->Attributes[("altitudefactor")] = getaltitudesetting(fDeviceInfo->ConservationSettings);
 	settingsNode->Attributes[("suunto:rgbm")] = getrgbmsetting(fDeviceInfo->ConservationSettings);

    DCDML_Node alarmNode(settingsNode->AddChild(("alarms")));
    DCDML_Node alarmtimeNode(alarmNode->AddChild(("suunto:timealarm")));
    	alarmtimeNode->Attributes[("enabled")] = (fDeviceInfo->AlarmEnables & 1) ? "true":"false";
    	alarmtimeNode->Attributes[value_str] = US2str(fDeviceInfo->AlarmTime);

    DCDML_Node alarmdepthNode(alarmNode->AddChild(("suunto:depthalarm")));
    	alarmdepthNode->Attributes["enabled"] = (fDeviceInfo->AlarmEnables & 2) ? "true":"false";
        switch(Units->units())
         {
            int result,temp;
        	case Units_Imperial:
        		alarmdepthNode->Attributes[value_str] = US2str(Units->depth(fDeviceInfo->AlarmDepth/128));
        		break;
        	case Units_Metric:
        	case Units_Scientific:
        	// round to 1/2 meters from CM
                result = Units->depth(fDeviceInfo->AlarmDepth/128) + 25;
                temp = result %100;
                result /= 100;
                if(temp > 50) sprintf(stringbuffer,"%.1f",double(result)+ 0.5);
                else sprintf(stringbuffer,"%.1f",double(result));
        		alarmdepthNode->Attributes[value_str] = stringbuffer;
        		break;
         }
    DCDML_Node lightNode(settingsNode->AddChild(("suunto:light")));
    	lightNode->Attributes[value_str] = UC2str((fDeviceInfo->Light & 0x7F));

	DCDML_Node personalinfoNode(settingsNode->AddChild(("suunto:personalinfo")));
    	personalinfoNode->Attributes[value_str] = getpersonalinfo();
 }

void OutputGeneraterT2D1::doprofile(DCDML_Node Node,DIVES *Data)
 {
    bool flag(false);
	DIVES D;
	if(Data->size() == 0)
     {
		 Node->AddComment("  No Dives  ");
		 return;
     }
    DIVES::iterator i(Data->begin());
    do
     {
		//D.push_front(*i);    // reverse the list
        if( (*i)->DiveNumber == 1 )
         {
         	if(flag==false)
             {
             	D.push_back(*i);
	            flag = true;
    	        ++i;
        	 	continue;
         	 }
         	DCDML_Node GroupNode(Node->AddChild("repetitiongroup"));
			builddive(GroupNode,D);
			D.clear();
            flag = false;
        	continue;
         }
        else
         {
         	D.push_back(*i);
            ++i;
         }
	 } while( i != Data->end() );
     
    // do any left overs
    if(D.size()>0)
     {
     	DCDML_Node GroupNode(Node->AddChild("repetitiongroup"));
        builddive(GroupNode,D);
     }
 }

void OutputGeneraterT2D1::builddive(DCDML_Node ParentNode,DIVES &D)
 {
	const char *c;
	DIVE d;
	DCDML_Node Node;
	DCDML_Node GasNode;
    int k(0);

	for(DIVES::const_iterator  i(D.begin()); i != D.end(); ++i)
	 {
        Trace(trace::TraceInfo,"Generate():: Dive %d",++k);
		DCDML_Node DiveNode = ParentNode->AddChild(("dive"));
		DCDML_Node SettingsNode = DiveNode->AddChild(("settings"));
		DCDML_Node StatsNode = DiveNode->AddChild(("statistics"));
		d = *i;
		settimestamp(DiveNode, d);

		sprintf(stringbuffer,"%02u:%02u:%02u",d->SurfaceIntervalHours,
					d->SurfaceIntervalMinutes,d->SurfaceIntervalSeconds);

		//DCDML_Node Node = DiveNode->AddChild(("surfaceinterval"));
		DiveNode->Attributes["surfaceinterval"] = stringbuffer;
		DiveNode->Attributes["id"] = US2str(d->DiveNumber);

	   //	Node = DiveNode->AddChild(("computermode"));
		SettingsNode->Attributes["computermode"] =getmode(d);

		//Node = DiveNode->AddChild(("personalfactor"));
		SettingsNode->Attributes["personalfactor"] = getpersonalsetting(d->ConservationSettings);

		//Node = DiveNode->AddChild(("altitudefactor"));
		SettingsNode->Attributes[("altitudefactor")] = getaltitudesetting(d->ConservationSettings);
		SettingsNode->Attributes[("suunto:rgbm")] = getrgbmsetting(d->ConservationSettings);

		Node = StatsNode->AddChild(("suunto:temperature"));
		Node->Attributes[("start")] = US2str(Units->temperature(d->StartingAirTemp));
		Node->Attributes[("atdepth")] = US2str(Units->temperature(d->TempAtDepth));
		Node->Attributes[("end")] = US2str(Units->temperature(d->EndingTemp));

		 // is this right????
		if (d->CNSClock >= 128)
		 {
			Node = StatsNode->AddChild(("cns"));
			Node->Attributes[("start")] = UC2str(d->CNSClock-128);
		 }
		 else
		  {
			  Node = StatsNode->AddChild(("suunto:otu"));
			  Node->Attributes[("value")] = UC2str(d->CNSClock);
		  }

		MixList.clear();
		switch(d->GasModel)
         {
			 default:
			 case 0: // == air
				addgastolist("Air",21, Units->pressure(d->StartingPressure),Units->pressure(d->EndingPressure));
				break;
			 case 1: //== nitrox
				addgastolist(d->GasMix, Units->pressure(d->StartingPressure),Units->pressure(d->EndingPressure));
				break;
			 case 2: // == gauge
				addgastolist("Gauge",0, Units->pressure(d->StartingPressure),Units->pressure(d->EndingPressure));
				break;
		 }

		Node = DiveNode->AddChild(("gasdefinitions"));

		dosamples(DiveNode,d);

		for( MIXLIST::iterator j(MixList.begin()); j != MixList.end(); ++j) addgasmix(*(*j),Node);
	 }

 }

 void OutputGeneraterT2D1::dosamples(DCDML_Node ParentNode, DIVE d) throw(sAPI::Error)
 {
	unsigned char *data(d->Profile);
	int len(d->ProfileLength);
	double depth(0.0);
	//DCDML_Node ENode;

	DCDML_Node Node(ParentNode->AddChild("samples"));
 	Node->Attributes["interval"] = AnsiString(d->SampleInterval).c_str();

	/* ------   do old profile data   ------- */
	// first set start gas then write out a depth(0)
	addgasswitch(Node, (*(MixList.begin()))->name.c_str(), 0);
	adddepth(Node,0.0);

	while(len--)
	 {
         unsigned char c(*data++);
		 switch(c)
		  {
				case pcGASCHANGE:
					if(len >0) --len;    // DONE 1: Needs a check for overrun error HERE
					else
                     {
						 throw sAPI::Error(L"GeneraterT2D1::dosamples() Missing Gas Switch Data",sAPI::DATA_MISMATCH);
                     }
					c=*data++;
                    dogasswitch(Node,c,-1);
                    break;
				case pcSLOW:
				case pcVIOLATION:
				case pcBOOKMARK:
				case pcSURFACED:
				case pcDECO:
				case pcCEILING:
				case pcMISSEDSTOP:
					eventstack.push(c);
					addevent(Node);
					break;

				case pcNA1:
				case pcEND:
				case pcEOD:
				case pcWORKLOAD:
				case pcNA2:
				case pcCOLDWATER:
				case pcNA3:
					continue;

				default:
					depth += double((signed char) c);
					adddepth(Node,depth);
		   }
	 }
	// and finaly write out a depth(0)
	adddepth(Node,0.0);

 }

void OutputGeneraterT2D1::adddepth(DCDML_Node Node,int depth, unsigned options,int pressure,int temp,int time) throw()
 {
	basicadddepth(Node,depth,options,pressure,temp,time);
	if(options & PUSHEDEVENT)
	 {
     	addevent(Node); // from DepthNode
	 }
 }


 // DONE 5 -c Critical: ERROR HERE
void OutputGeneraterT2D1::addevent(DCDML_Node Node) throw()
 {
	DCDML_Node ENode(Node->AddChild("event"));
    while(eventstack.empty() == false)
     {
		unsigned char c(eventstack.pop());
		switch(c)
		 {
			//case pcGASCHANGE:
			 //	break;
			case pcSLOW:
			case pcVIOLATION:
			case pcBOOKMARK:
			case pcSURFACED:
			case pcDECO:
			case pcCEILING:
			case pcMISSEDSTOP:
				ENode->Attributes[id_str] = doevent(c);
				break;
		 }
     }
 }
 
const char * const OutputGeneraterT2D1::doevent(unsigned char c) throw()
 {
	switch(c)
	 {
		case pcSLOW: c=0;break;
		case pcVIOLATION: c=1;break;
		case pcBOOKMARK: c=2;break;
		case pcSURFACED: c=3;break;
		case pcDECO: c=4;break;
		case pcCEILING: c=5;break;
		case pcMISSEDSTOP: c=7;break;
	 }
	return event[c];
 }

 
const char * const OutputGeneraterT2D1::getrgbmsetting(unsigned s) throw()
 {
 	unsigned r((s & 0x10)>>4);
    if(fDeviceInfo->ComputerModel == 0xB) r =!r;
	if(r) return rgbm_str[1];
	else return  rgbm_str[0];
 }

