

#ifdef _DEBUG
		  
#include "Headers\sAPI_Comm.h"
#include "Headers\sAPI_Helper.h"
#include <iostream>
#include <fstream>


extern struct sAPI::COMMOPTIONS CommOption2;

namespace sAPI
{

const int HIGHByte = 3;
const int LOWByte = 4;

void __stdcall CommModel2F::Open(int z) throw(Error)
 {
	infile.open(fPort,std::ios_base::binary);
	if(!infile.is_open())
	 {
		throw( Device_Not_Present(L"Device Type2F Not Found") );
	 }
	fCommOpen = true;
	// fill file buffer
	infile.read(file,0x8000);
 }

CommModel2F::CommModel2F(const wchar_t *port, volatile const bool& t, size_t tries)
	: Device_Comm(0,CommOption2,t,tries), fCommOpen(false), fPort(port)
 {
	file = new unsigned char [0x8000 ];
 }

CommModel2F::~CommModel2F()
 {
	delete [] file;
	if(fCommOpen == false) return;
	infile.close();
	fCommOpen = false;
 }

void CommModel2F::SetCommState(bool state) throw()
 {
	ClearCommError(commport(),&ComErrorMask,&ComStat);
	switch(state)
     {
	   case _WRITE:
			SetRTS(false);
			break;

       case _READ:
			SetRTS(true);
			break;
	 }
	fState = state;
	return;
 }

void CommModel2F::Talk(int bytes)  throw(Error)
 {
	AddressHigh = CommandBuffer[HIGHByte];
	AddressLow = CommandBuffer[LOWByte];
	AddressSize = CommandBuffer[5];
 }

void CommModel2F::Listen(int bytes)  throw(Error)
 {
	unsigned offset = AddressHigh<<8;
	offset += AddressLow;
	DataBuffer[0] = 0x5;
	DataBuffer[1] = 0;
	DataBuffer[2] = AddressSize+3;
	DataBuffer[3] = AddressHigh;
	DataBuffer[4] = AddressLow;
	DataBuffer[5] = AddressSize;
	if((offset+AddressSize)>0x8000)
	 {
		throw CommError(BAD_READ_PARAM,L"Listen: Range");
	 }

	memcpy(&DataBuffer[6],&file[offset],AddressSize);
 }
}
 #endif
